#include <bits/stdc++.h>
using namespace std;
int main()
{
	int t;
	scanf("%i",&t);
	while(t--)
	{
		long long n,m;
		scanf("%lld%lld",&n,&m);
		long long a[n+1],b[m+1],g,tf=0;
		for(long long i=1;i<=n;i++)
		{
			scanf("%lld",&a[i]);
		}
		for(long long i=1;i<=m;i++)
		{
			scanf("%lld",&b[i]);
		}
		sort(a+1,a+n+1);
		sort(b+1,b+m+1);
		g=a[2]-a[1];
		for(long long i=2;i<=n;i++)
		{
			if((a[i]-a[i-1])%g!=0)
			{
				printf("0");
				tf=1;
				//printf(" OVDE JE i=%i ",i);
				//printf("g=%i\n",a[i]-a[i-1]);
				break;
			}
		}
		if(tf==1)
		{
			continue;
		}
		tf=0;
		for(long long i=1,j=1;i<=n,j<=m;i++,j++)
		{
			if((b[j]-a[i])%g==0)
			{
				printf("0\n");
				tf=1;
				break;
			}
			if(a[i]>b[j])
			{
				i--;
				continue;
			}
			else if(a[i]==b[j])
			{
				printf("0\n");
				tf=1;
				break;
			}
			else if(a[i]<b[j])
			{
				j--;
				continue;
			}
		}
		if(tf==0)
		{
			printf("1\n");
		}
	}
	return 0;
}